SETLOCAL
@ECHO OFF

set PROJECT_NAME=chef-workstation
set PIPELINE_NAME=chef-workstation

IF EXIST "%CD%\opscode-ci\scripts\build-init.bat" (
  call opscode-ci\scripts\build-init.bat
) ELSE (
  call opscode-ci\scripts\default-init.bat
)

cd omnibus
SET PROJECT_NAME=chef-workstation
SET INSTALL_DIR=C:\opscode\%PROJECT_NAME%
SET OMNIBUS_CACHE_DIR=C:\omnibus-ruby

ECHO(
ECHO(
ECHO ============================================================
ECHO Preparing build environment for %PROJECT_NAME%
ECHO ============================================================
ECHO(

IF "%EXPIRE_CACHE%"=="true" (

  ECHO(
  ECHO Deleting the Omnibus cache directory at %OMNIBUS_CACHE_DIR%
  ECHO(

  rmdir /Q /S C:\omnibus-ruby 2>NUL

  ECHO(
  ECHO DONE! \m/
  ECHO(
)

rmdir /Q /S %INSTALL_DIR% 2>NUL
del /Q /S /F %OMNIBUS_CACHE_DIR%\build\chef-workstation\*.manifest 2>NUL
rmdir /Q /S .\pkg 2>NUL
rmdir /Q /S %OMNIBUS_CACHE_DIR%\pkg 2>NUL

IF NOT EXIST "%CD%\omnibus.rb" (
  call copy /Y omnibus.rb.example omnibus.rb 2>NUL
)

call bundle install --without development --retry 5 || GOTO :error

FOR /F %%I IN ('bundle exec gem list "^omnibus$" --installed --version ">= 3.0.0"') DO set OMNIBUS_3=%%I
FOR /F %%I IN ('bundle exec gem list "^omnibus$" --installed --version ">= 4.0.0.beta"') DO set OMNIBUS_4=%%I

IF EXIST "%CD%\config\projects\%PROJECT_NAME%-windows.rb" (
  set PROJECT_NAME=%PROJECT_NAME%-windows
)

set OMNIBUS_BUILD_OPTIONS=

IF "%OMNIBUS_3%"=="true" (
  set OMNIBUS_BUILD_OPTIONS=-l debug
)

IF "%OMNIBUS_4%"=="true" (
  set OMNIBUS_BUILD_OPTIONS=-l internal --override fatal_licensing_warnings:true
)

IF "%APPEND_TIMESTAMP%"=="false" (
  IF "%OMNIBUS_3%"=="true" (
    set OMNIBUS_BUILD_OPTIONS=%OMNIBUS_BUILD_OPTIONS% append_timestamp:false
  ) ELSE (
    set OMNIBUS_BUILD_OPTIONS=%OMNIBUS_BUILD_OPTIONS% --no-timestamp
  )
)

ECHO(
ECHO(
ECHO ============================================================
ECHO Performing build of %PROJECT_NAME%
ECHO ============================================================
ECHO(

IF "%OMNIBUS_3%"=="true" (
  call bundle exec omnibus build %PROJECT_NAME% %OMNIBUS_BUILD_OPTIONS% || GOTO :error
) ELSE (
  call bundle exec omnibus build project %PROJECT_NAME% %OMNIBUS_BUILD_OPTIONS% || GOTO :error
)

powershell -ExecutionPolicy Unrestricted -Command "Get-Content \"$env:INSTALL_DIR\version-manifest.txt\" | Where-Object{$_ -match \"$env:PROJECT_NAME\"} | Select-Object -first 1 | %%{$build_version = $_.split(' ')[1]; Write-Output \"OMNIBUS_BUILD_VERSION=$build_version\"}" >> pkg\OMNIBUS_BUILD_VERSION.properties

GOTO :EOF

:error

ECHO Failed with error level %ERRORLEVEL%

EXIT %ERRORLEVEL%

@ECHO ON
ENDLOCAL