SETLOCAL
@ECHO OFF

set PROJECT_NAME=omnibus-toolchain
set PIPELINE_NAME=omnibus-toolchain

IF EXIST "%CD%\opscode-ci\scripts\test-init.bat" (
  call opscode-ci\scripts\test-init.bat
) ELSE (
  call opscode-ci\scripts\default-init.bat
)

@ECHO OFF

SET INSTALL_DIR=C:\opscode\%PROJECT_NAME%
SET PSModulePath=%PSMODULEPATH%;%ProgramFiles(x86)%\Windows Installer PowerShell Module\

ECHO(
ECHO(
ECHO ============================================================
ECHO Removing previous install of %PROJECT_NAME%
ECHO ============================================================
ECHO(

FOR %%i IN (%PROJECT_NAME%*.msi) DO SET PACKAGE_FILE=%%i

IF "%PACKAGE_FILE%" == "" (
  ECHO ERROR: Missing MSI artifact for %PROJECT_NAME%!
  exit /b 1
) ELSE (
  SET PACKAGE_FILE=%WORKSPACE%\%PACKAGE_FILE%
)
ECHO Programmatically extracting base product name from %PACKAGE_FILE%
ECHO(

FOR /F "delims=" %%i IN ('powershell -ExecutionPolicy Unrestricted -Command "Import-Module MSI; Get-MSIProperty ProductName -Path %PACKAGE_FILE% | ForEach { $_.Value.Split(\"v[0-9]\")[0].TrimEnd() }"') DO set BASE_PRODUCT_NAME=%%i

ECHO Extracted base product name of "%BASE_PRODUCT_NAME%"
ECHO(

ECHO Uninstalling all previous versions of "%BASE_PRODUCT_NAME%"
powershell -ExecutionPolicy Unrestricted -Command "Get-WmiObject -Class Win32_Product -Filter \"Name LIKE '%BASE_PRODUCT_NAME%%%'\" | ForEach { $_.Uninstall() | Out-Null }" || GOTO :error

rmdir /S /Q %INSTALL_DIR% 2>NUL

ECHO(
ECHO(
ECHO DONE! \m/
ECHO(

ECHO(
ECHO(
ECHO ============================================================
ECHO Installing %PROJECT_NAME%
ECHO ============================================================
ECHO(

ECHO Installing from: %PACKAGE_FILE%

call msiexec INSTALLLOCATION=C:\opscode /qb /i %PACKAGE_FILE% || GOTO :error

ECHO(
ECHO(
ECHO DONE! \m/
ECHO(

ECHO(
ECHO(
ECHO ============================================================
ECHO Running verification for %PROJECT_NAME%
ECHO ============================================================
ECHO(

SET PATH=%INSTALL_DIR%\bin;%PATH%


ECHO(
ECHO(
ECHO DONE! \m/
ECHO(

GOTO :EOF

:error

ECHO Failed with error level %ERRORLEVEL%

EXIT %ERRORLEVEL%

@ECHO ON
ENDLOCAL